//DSP_FPGA workshop 2005
//2005/8/24
`timescale 1ps / 1ps
module gazou_gen (
  p_clk,
  rstb,
  tmg_sync,
  tmg_da_en,
  gen_da_en,
  gen_da_r,
  gen_da_g,
  gen_da_b,
  gen_sync);

  input p_clk;
  input rstb;
  input tmg_sync;
  input tmg_da_en;
  output gen_da_en;
  output [7:0]gen_da_r;
  output [7:0]gen_da_g;
  output [7:0]gen_da_b;
  output gen_sync;

  reg gen_da_en;
  reg [7:0]gen_da_r;
  reg [7:0]gen_da_g;
  reg [7:0]gen_da_b;
  reg gen_sync; 
  reg [9:0] v_c;
  reg [9:0] h_c;
  reg [7:0] bv_c;
  reg [7:0] bh_c;

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    v_c <= 10'd0;
    h_c <= 10'd0;
  end
else
	if (tmg_sync==1'b1)
      begin  
        v_c <= 10'd0;
        h_c <= 10'd0;
      end
    else
      if (tmg_da_en==1'b1)
      	if (h_c == 10'd799)
          begin
            h_c <= 10'd0;
      		if (v_c == 10'd599)
              v_c <= 10'd0;
      		else
              v_c <= v_c + 10'd1;
      	  end
        else
      	  begin
            h_c <= h_c +10'd1;
            v_c <= v_c ;
      	  end
      else
      	begin
          h_c <= h_c ;
          v_c <= v_c ;
        end

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    bv_c <= 8'd0;
    bh_c <= 8'd0;
  end
else
  if ((tmg_da_en==1'b1)&&(h_c == 10'd799)&&(v_c == 10'd599))
		if(bv_c==8'd0)
		  if (bh_c==8'd100)
			begin
			  bh_c <= 8'd100;
			  bv_c <= 8'd2;
			end
          else
			bh_c <= bh_c +8'd2;
			//bh_c <= bh_c +8'd4;
        else
		  if (bh_c==8'd100)
		    if(bv_c==8'd100)
			  begin
			    bv_c <= 8'd100;
			    bh_c <= 8'd98;
			  end
            else
			  bv_c <= bv_c +8'd2;
          else
		    if(bv_c==8'd100)
		      if (bh_c==8'd0)
				begin
			      bh_c <= 8'd0;
			      bv_c <= 8'd98;
				end
              else
			    bh_c <= bh_c -8'd2;
            else			  
		      if (bh_c==8'd0)
		        if(bv_c==8'd0)
				  begin
			       bv_c <= 8'd0;
			       bh_c <= 8'd2;
				  end
                else
			      bv_c <= bv_c -8'd2;
    else
	  begin
        bv_c <= bv_c;
        bh_c <= bh_c;
      end	
   
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin
    gen_da_r <= 8'd0;
    gen_da_g <= 8'd0;
    gen_da_b <= 8'd0;
	gen_da_en <= 1'b0;
	gen_sync <= 1'b0;
  end
else
    begin
      gen_da_en <= tmg_da_en ;
      gen_sync <= tmg_sync ;
      gen_da_r <= 8'd0;
      gen_da_g <= 8'd0;
      gen_da_b <= 8'd0;
      //if ((v_c==0)&&(h_c==0))
      //  gen_da_r <= 8'd100;
      if (((v_c>=60)&&(v_c<=280)&&(h_c>=160)&&(h_c<=380))||
            ((v_c>=300)&&(v_c<=520)&&(h_c>=400)&&(h_c<=620)))
        gen_da_r <= 8'd255;
    	if ((v_c>=140)&&(v_c<=360)&&(h_c>=240)&&(h_c<=460))
        gen_da_g <= 8'd255; 
    	if ((v_c>=220)&&(v_c<=440)&&(h_c>=320)&&(h_c<=540))
        gen_da_b <= 8'd255;
      if ((v_c>=60)&&(v_c<=571)&&(h_c>=80)&&(h_c<=120))
    	begin
          gen_da_r <= v_c[9:1]-8'd30;
          gen_da_g <= v_c[9:1]-8'd30;
          gen_da_b <= v_c[9:1]-8'd30;
        end
      if ((v_c>=540)&&(v_c<=576))
	    if (((h_c>=200)&&(h_c<=205))||
            ((h_c>=250)&&(h_c<=254))||
            ((h_c>=300)&&(h_c<=303))||
            ((h_c>=350)&&(h_c<=352))||
            ((h_c>=400)&&(h_c<=401)))
		  begin
            gen_da_r<=8'd255;
	        gen_da_g<=8'd255;
	        gen_da_b<=8'd255;
		  end
      if ((v_c>=bv_c+50)&&(v_c<=bv_c+70)&&
          (h_c>=bh_c+600)&&(h_c<=bh_c+620))
		  begin
            gen_da_r<=8'd255;
	        gen_da_g<=8'd255;
	        gen_da_b<=8'd255;
		  end
    end

endmodule








