//DSP_FPGA workshop 2005
//2005/8/24
`timescale 1ps / 1ps
module gazou_syori (
  p_clk,
  rstb,
  gen_da_en,
  gen_da_r,
  gen_da_g,
  gen_da_b,
  gen_sync,
  out_da_r,
  out_da_g,
  out_da_b,
  out_da_en,
  hanten,
  mono,
  fir);

  input p_clk;
  input rstb;
  input gen_da_en;
  input [7:0]gen_da_r;
  input [7:0]gen_da_g;
  input [7:0]gen_da_b;
  input gen_sync;   
  output [7:0]out_da_r;
  output [7:0]out_da_g;
  output [7:0]out_da_b;
  output  out_da_en;
  input  hanten;
  input  mono ;
  input  fir;
  
  reg [7:0]h_da_r;
  reg [7:0]h_da_g;
  reg [7:0]h_da_b;
  reg [7:0]c_da_r;
  reg [7:0]c_da_g;
  reg [7:0]c_da_b;
  reg [7:0]f_da_r;
  reg [7:0]f_da_g;
  reg [7:0]f_da_b;
  reg [17:0]r_tmp;
  reg [17:0]g_tmp;
  reg [17:0]b_tmp;
  reg  out_da_en;
  reg [9:0] v_c;
  reg [9:0] h_c;
  reg [9:0] h_c_1;
  reg [9:0] h_c_2;
  reg [7:0] da_r0;
  reg [7:0] da_r1;
  reg [7:0] da_r2;
  reg [7:0] da_r3;
  reg [7:0] da_r4;
  reg [7:0] da_g0;
  reg [7:0] da_g1;
  reg [7:0] da_g2;
  reg [7:0] da_g3;
  reg [7:0] da_g4;
  reg [7:0] da_b0;
  reg [7:0] da_b1;
  reg [7:0] da_b2;
  reg [7:0] da_b3;
  reg [7:0] da_b4;
  reg [19:0] da_tmp2;

  reg [11:0] f_da_r_tmp;
  reg [11:0] f_da_g_tmp;
  reg [11:0] f_da_b_tmp;

  wire [7:0] fda_r0;
  wire [7:0] fda_r1;
  wire [7:0] fda_r2;
  wire [7:0] fda_r3;
  wire [7:0] fda_r4;
  wire [7:0] fda_g0;
  wire [7:0] fda_g1;
  wire [7:0] fda_g2;
  wire [7:0] fda_g3;
  wire [7:0] fda_g4;
  wire [7:0] fda_b0;
  wire [7:0] fda_b1;
  wire [7:0] fda_b2;
  wire [7:0] fda_b3;
  wire [7:0] fda_b4;

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    v_c <= 10'd0;
    h_c <= 10'd0;
  end
else
    if (gen_sync==1'b0)
    	  begin 
          v_c <= 10'd0;
          h_c <= 10'd0;
        end
    else
      if (gen_da_en==1'b1)
      	  if (h_c == 10'd799)
      		begin
              h_c <= 10'd0;
      		  if (v_c == 10'd599)
                v_c <= 10'd0;
      		  else
                v_c <= v_c + 10'd1;
      		end
          else
      		begin
              h_c <= h_c +10'd1;
              v_c <= v_c ;
      		end
       else
      	 begin
           h_c <= h_c ;
           v_c <= v_c ;
      	 end

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin	
    da_r0 <= 8'd0;
    da_r1 <= 8'd0;
    da_r2 <= 8'd0;
    da_r3 <= 8'd0;
    da_r4 <= 8'd0;
    da_g0 <= 8'd0;
    da_g1 <= 8'd0;
    da_g2 <= 8'd0;
    da_g3 <= 8'd0;
    da_g4 <= 8'd0;
    da_b0 <= 8'd0;
    da_b1 <= 8'd0;
    da_b2 <= 8'd0;
    da_b3 <= 8'd0;
    da_b4 <= 8'd0;
	h_c_1 <= 10'd0;
	h_c_2 <= 10'd0;
  end
else
	begin
	  da_r0 <= gen_da_r;
	  da_r1 <= da_r0;
	  da_r2 <= da_r1;
	  da_r3 <= da_r2;
	  da_r4 <= da_r3;
	  da_g0 <= gen_da_g;
	  da_g1 <= da_g0;
	  da_g2 <= da_g1;
	  da_g3 <= da_g2;
	  da_g4 <= da_g3;
	  da_b0 <= gen_da_b;
	  da_b1 <= da_b0;
	  da_b2 <= da_b1;
	  da_b3 <= da_b2;
	  da_b4 <= da_b3;
	  h_c_1 <= h_c;
	  h_c_2 <= h_c_1;
	end
 
   assign fda_r4 =(h_c_2==10'd0)?da_r2:
                    (h_c_2==10'd1)?da_r3:da_r4;
   assign fda_r3 =(h_c_2==10'd0)?da_r2:da_r3;
   assign fda_r2 = da_r2;
   assign fda_r1 =(h_c_2==10'd699)?da_r2:da_r1;
   assign fda_r0 =(h_c_2==10'd698)?da_r1:
                    (h_c_2==10'd699)?da_r2:da_r0;
   assign fda_g4 =(h_c_2==10'd0)?da_g2:
                    (h_c_2==10'd1)?da_g3:da_g4;
   assign fda_g3 =(h_c_2==10'd0)?da_g2:da_g3;
   assign fda_g2 = da_g2;
   assign fda_g1 =(h_c_2==10'd699)?da_g2:da_g1;
   assign fda_g0 =(h_c_2==10'd698)?da_g1:
                    (h_c_2==10'd699)?da_g2:da_g0;
   assign fda_b4 =(h_c_2==10'd0)?da_b2:
                    (h_c_2==10'd1)?da_b3:da_b4;
   assign fda_b3 =(h_c_2==10'd0)?da_b2:da_b3;
   assign fda_b2 = da_b2;
   assign fda_b1 =(h_c_2==10'd699)?da_b2:da_b1;
   assign fda_b0 =(h_c_2==10'd698)?da_b1:
                    (h_c_2==10'd699)?da_b2:da_b0;
   
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin
    h_da_r <= 8'd0;
    h_da_g <= 8'd0;
    h_da_b <= 8'd0;
  end
else
  begin
    h_da_r  <= 8'd255-gen_da_r;
    h_da_g  <= 8'd255-gen_da_g;
    h_da_b  <= 8'd255-gen_da_b;
  end

   
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin
    c_da_r <= 8'd0;
    c_da_g <= 8'd0;
    c_da_b <= 8'd0;
  end
else
  begin
    da_tmp2 =  (10'd306*gen_da_r + 10'd601*gen_da_g + 10'd117*gen_da_b);
    c_da_r  <= da_tmp2[17:10]; // 1/1024
    c_da_g  <= da_tmp2[17:10];
    c_da_b  <= da_tmp2[17:10];
  end
 
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin
    f_da_r <= 8'd0;
    f_da_g <= 8'd0;
    f_da_b <= 8'd0;
  end
else
  begin
	/*
    f_da_r  <= (fda_r0+fda_r1+fda_r2+fda_r3+fda_r4)/5;
    f_da_g  <= (fda_g0+fda_g1+fda_g2+fda_g3+fda_g4)/5;
    f_da_b  <= (fda_b0+fda_b1+fda_b2+fda_b3+fda_b4)/5;
	*/
	/*
    f_da_r_tmp <= (fda_r0+fda_r1+fda_r2+fda_r3+fda_r4);
    f_da_g_tmp <= (fda_g0+fda_g1+fda_g2+fda_g3+fda_g4);
    f_da_b_tmp <= (fda_b0+fda_b1+fda_b2+fda_b3+fda_b4);
    f_da_r  <= f_da_r_tmp/5;
    f_da_g  <= f_da_g_tmp/5;
    f_da_b  <= f_da_b_tmp/5;
    */
	
    r_tmp = (fda_r0+fda_r1+fda_r2+fda_r3+fda_r4)*6'd51;
    g_tmp = (fda_g0+fda_g1+fda_g2+fda_g3+fda_g4)*6'd51;
    b_tmp = (fda_b0+fda_b1+fda_b2+fda_b3+fda_b4)*6'd51;
    f_da_r  <= r_tmp[15:8];
    f_da_g  <= g_tmp[15:8];
    f_da_b  <= b_tmp[15:8];
	
  end

  assign out_da_r = (hanten==1'b0)?h_da_r:(mono==1'b0)?c_da_r:(fir==1'b0)?f_da_r:da_r0;
  assign out_da_g = (hanten==1'b0)?h_da_g:(mono==1'b0)?c_da_g:(fir==1'b0)?f_da_g:da_g0;
  assign out_da_b = (hanten==1'b0)?h_da_b:(mono==1'b0)?c_da_b:(fir==1'b0)?f_da_b:da_b0;
   

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  out_da_en <= 1'b0;
else
  out_da_en <= gen_da_en;
   
endmodule






