//DSP_FPGA workshop 2005
//2005/8/24
`timescale 1ps / 1ps
module gazou_test;

  parameter CLK_TIME_P   = 10000; //100MHz
  //parameter CLK_TIME_P   = 5000; //200MHz
  integer        lp1;
  integer 		 fp0,fp1,fp2,fp3;
   integer 		 m;
   
  reg clk;
  reg rstb;
  wire out_da_en;
  wire [7:0]out_da_r;
  wire [7:0]out_da_g;
  wire [7:0]out_da_b;
  wire  out_vsync_n;
  wire  out_hsync_n;
  reg  hanten;
  reg  mono ;
  reg  fir;
  wire p_clk;
  reg out_da_en_d1;
  reg out_da_en_d2;
  reg out_da_en_d3;
  reg out_da_en_d4;
  reg out_vsync_n_d1;
      
gazou dut (
  .clk(        clk),        
  .rstb(       rstb),       
  .p_clk( p_clk),   
  .out_da_en( out_da_en), 
  .out_da_r( out_da_r), 
  .out_da_g( out_da_g), 
  .out_da_b( out_da_b), 
  .out_vsync_n(   out_vsync_n), 
  .out_hsync_n(   out_hsync_n), 
  .sync_n(   sync_n), 
  .hanten(hanten),
  .mono(mono),
  .fir(fir)   
);

initial begin
  fp0 = $fopen("input_rtl.txt");   
  fp1 = $fopen("hanten_rtl.txt");   
  fp2 = $fopen("mono_rtl.txt");   
  fp3 = $fopen("fir_rtl.txt");
end   
//
// CLK generator
//    
always
  begin
    clk <= 1'b0;
    #(CLK_TIME_P/2);
    clk <= 1'b1;
    #(CLK_TIME_P/2);
  end  

initial
  begin
    rstb <= 1'b0;
    hanten <= 1'b1;
    mono <= 1'b1;
    fir <= 1'b1;
	m =0;
	
    @(posedge clk);
    rstb <= 1'b1;
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    while(!((out_vsync_n==1'b1)&&(out_vsync_n_d1==1'b0)))
      @(posedge clk);
    m =1;
    hanten <= 1'b0;
    mono <= 1'b1;
    fir <= 1'b1;	
    rstb <= 1'b0;	
    @(posedge clk);
    rstb <= 1'b1;
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    while(!((out_vsync_n==1'b1)&&(out_vsync_n_d1==1'b0)))
      @(posedge clk);
    m =2;
    hanten <= 1'b1;
    mono <= 1'b0;
    fir <= 1'b1;
    rstb <= 1'b0;	
    @(posedge clk);
    rstb <= 1'b1;
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    while(!((out_vsync_n==1'b1)&&(out_vsync_n_d1==1'b0)))
      @(posedge clk);
    m =3;
    hanten <= 1'b1;
    mono <= 1'b1;
    fir <= 1'b0;
    rstb <= 1'b0;	
    @(posedge clk);
    rstb <= 1'b1;
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    @(posedge clk);
    while(!((out_vsync_n==1'b1)&&(out_vsync_n_d1==1'b0)))
      @(posedge clk);
    @(posedge clk);
    @(posedge clk);
	//$stop;
	$finish;
  end


always @ (posedge p_clk )
  begin
    out_vsync_n_d1 <= out_vsync_n;
	out_da_en_d1 <= out_da_en;
	out_da_en_d2 <= out_da_en_d1;
	out_da_en_d3 <= out_da_en_d2;
	out_da_en_d4 <= out_da_en_d3;
	if (fir==1'b1)
      begin
        if (out_da_en==1'b1)
	       begin
			  if (m==0)
                $fdisplay(fp0,"%d %d %d",out_da_r,out_da_g,out_da_b);
		  	  if (m==1)
                $fdisplay(fp1,"%d %d %d",out_da_r,out_da_g,out_da_b);
			  if (m==2)
                $fdisplay(fp2,"%d %d %d",out_da_r,out_da_g,out_da_b);
	       end
	  end
    else
      if (out_da_en_d3==1'b1) 
      //if (out_da_en_d4==1'b1) 
        $fdisplay(fp3,"%d %d %d",out_da_r,out_da_g,out_da_b);
  end
   
endmodule



