//DSP_FPGA workshop 2005
//2005/8/24
`timescale 1ps / 1ps
module gazou_tmg (
  clk,
  rstb,
  tmg_da_en,
  out_hsync_n,
  out_vsync_n,
  p_clk,
  tmg_sync);

  input clk;
  input rstb;
  output tmg_da_en;
  output out_vsync_n;
  output out_hsync_n;
  output p_clk;
  output tmg_sync;
   
  reg tmg_da_en;
  reg [9:0] vsync_cnt;
  reg [10:0] hsync_cnt;
  reg vsync;
  reg hsync;
  reg p_clk ;
  reg tmg_sync;
  reg [4:0]vsync_shift;
  reg [4:0]hsync_shift;

   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  p_clk <= 1'b0;
else
  p_clk <= ~p_clk;
   
 
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    vsync_cnt <= 10'd0;
    hsync_cnt <= 11'd0;
  end
else
    if (hsync_cnt == 11'd1039)
	  begin
        hsync_cnt <= 11'd0;
	    if (vsync_cnt == 10'd665)
          vsync_cnt <= 10'd0;
        else
          vsync_cnt <= vsync_cnt + 10'd1;
	  end
    else
	  begin
        hsync_cnt <= hsync_cnt +11'd1;
        vsync_cnt <= vsync_cnt ;
	  end
/*
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin 
	tmg_sync  <= 1'b1; 
  end
else
  begin
	if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))
	  tmg_sync  <= 1'b1;
  end

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin 
	tmg_sync  <= 1'b1; 
  end
else
  begin
	if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd1))
	  tmg_sync  <= 1'b0;
  end
*/

always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin 
	tmg_sync  <= 1'b1; 
  end
else
  begin
	if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))
	  tmg_sync  <= 1'b1;
    else 
	  tmg_sync  <= 1'b0;
  end
 
   
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin 
    vsync <= 1'b0;
    hsync <= 1'b0;
    tmg_da_en <= 1'b0;
  end
else
  begin
	//VSYNC
	if ((vsync_cnt==10'd6)&&(hsync_cnt==11'd199))
	  vsync <= 1'b1;
	else
	  if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd199))
	    vsync <= 1'b0;
	  else
	    vsync <= vsync;
	//HSYNC
	if (hsync_cnt==11'd79)
	    hsync <= 1'b1;
     else
	   if  (hsync_cnt==11'd1039)
		 hsync <= 1'b0;
	   else
		 hsync <= hsync;
	if((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))	  
      tmg_da_en <= 1'b0;
	else
	  if ((vsync_cnt>=10'd29)&&(vsync_cnt <= 10'd628))
		if (hsync_cnt==11'd199)
		  tmg_da_en <= 1'b1;
	    else
		  if  (hsync_cnt==11'd999)
		   tmg_da_en <= 1'b0;
	      else
		    tmg_da_en <= tmg_da_en;
	  else
		tmg_da_en <= 1'b0;
  end

   
always @ (posedge p_clk or negedge rstb )
if (rstb==1'b0) 
  begin 
	vsync_shift <= 5'b00000;
	hsync_shift <= 5'b00000;
  end
else
  begin
    vsync_shift <= {vsync_shift[3:0],vsync};
    hsync_shift <= {hsync_shift[3:0],hsync};
  end

assign out_vsync_n = ~vsync_shift[4];
assign out_hsync_n = ~hsync_shift[4];

endmodule








